/* jshint esversion : 6 */
const { dataType, convertDataType, isNumber, getDataType } = require('../../data-type');



/**
 * ritorna il tipo di dato e la sua lunghezza...ad Esempio => varchar(255)
 * @param {Object} 
 */
exports.setColumnType = ({ length, type }) => {

    //
    const __type = convertDataType(type);

    //
    const { requireLength, length: optionalLength } = dataType.find(e => e.value === __type);
    //
    const __requireLength = (length, type) => (type + '(' + length.toString().replace(/\.{1}/g, ',') + ')');



    if (requireLength || length && optionalLength) {
        if (requireLength || optionalLength)
            return __requireLength(length, type);
        else
            throw "Error: data_type '" + e + "' requires length";
    } else
        return type;

};


exports.setColumnDefault = function(o) {

    const { null: _null, default: _default, type } = (o || {});



    const __defaultAsNull = ("string" === typeof _default && _default.match(/^(not null|null)$/i));


    let r = "";
    //
    if (o && o.hasOwnProperty('null') && !__defaultAsNull)
        r = (!_null || "string" === typeof _null && _null.match(/^no/i)) ? ' NOT NULL ' : ' NULL ';
    //
    else if (_default) {
        if (__defaultAsNull)
            r += (' ' + _default.toUpperCase() + ' ');
        //
        else if (typeof _default !== "undefined") {

            r += " DEFAULT ";
            if (!_default.toString().length)
                r += isNumber(type) > -1 ? "  NULL " : "''";
            else
                r += _default;
        }
    }


    return r;

};


exports.setColumnLength = a => a.replace(/(^\D+?\(|\)$)|(^\D+$)/g, "");


exports.getColumnType = getDataType;