/* jshint esversion : 6*/



/* ========================================================================== */
//
// @objWhere constructor must be Object 
// - values of objWhere can contain any "split" characters : 
//      |? => OR
//      &? => AND
//
// . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
// 
// - from values of the second key the string can start with &? or |? (have same means of split value)
//      it's useful to constraint the concat of values with AND or OR
//
// . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
// 
//
//
/* ========================================================================== */

module.exports = obj => {

    if (!obj)
        return "";

    const __numOfFields = Object.keys(obj).length;
    const __endIteration = (__numOfFields - 1);


    const x = {
        setQueryPath() {
            let queryStringPath = ' WHERE ',
                i = 0;

            const __setNode = (a, field) => {
                const __l = a.length;

                a.forEach((v, i) => {
                    if (['&', '|'].indexOf(v) === -1)
                        queryStringPath += this.buildClause(field, v, __l, i);
                });

                if (i < __endIteration && __numOfFields > 1) {
                    if (a[0].match(/\&{1}\s{0,}$/))
                        queryStringPath += ' AND ';
                    else if (a[0].match(/\|{1}\s{0,}$/))
                        queryStringPath += ' OR ';
                    else
                        queryStringPath += ' AND ';

                }

                i++;
            };



            Object.entries(obj).forEach(([field, fieldValue]) => {
                const v = fieldValue.toString().split(/\s{0,}\?\s{0,}/g);
                __setNode(v, field);
            });



            return queryStringPath;
        },

        /**
         * @param {string} field "field of where clause" 
         * @param {string|number} optionValue "value of the option" 
         * @param {number} endInteration "value of last index" 
         * @param {number} index "value of current index" 
         */
        buildClause(field, optionValue, endInteration, index) {

            const __clear = /^\={1}|!{1}={1}\s{0,}|>{1}={1}\s{0,}|[<]{1}\s{0,}|>{1}\s{0,}|\&{1}\s{0,}$|\|{1}\s{0,}$/;


            let str = "";

            // se inizia con =
            if (optionValue.match(/^\={1}\s{0,}./))
                str = (field + ' = ');
            // se inizia con !=
            else if (optionValue.match(/^\!{1}={1}\s{0,}.+/))
                str = (field + ' <> ');
            // se inizia con >=
            else if (optionValue.match(/^\>{1}={1}\s{0,}\d+/))
                str = (field + ' >= ');
            // se inizia con <= seguito da (spazio opzionale) e numeri
            else if (optionValue.match(/^[<]{1}=*?\s{0,}\d+/))
                str = (field + ' <= ');
            // se inizia con >
            else if (optionValue.match(/^\>{1}\s{0,}\d+/))
                str = (field + ' > ');
            // se inizia con <
            else if (optionValue.match(/^[<]{1}\s{0,}\d+/))
                str = (field + ' < ');
            // se inizia con %str% || %str || str%
            else if (optionValue.match(/^%{1}.+%{1}$|^%{1}.+|^.+%{1}$/))
                str = (field + ' LIKE ');
            // se inizia con !%str% || !%str  || !str%
            else if (optionValue.match(/^!{1}(%{1}.+%$|%{1}.+|^.%{1}$)/))
                str = (field + ' NOT LIKE ');
            else
                str = (field + ' = ');



            const val = str => (isNaN(str) ? '"' + str + '"' : str);
            str += val(optionValue.replace(__clear, ""));

            if (optionValue.match(/\&{1}\s{0,}$/))
                str += ' AND ';
            else if (optionValue.match(/\|{1}\s{0,}$/))
                str += ' OR ';
            else if (endInteration > 1 && endInteration < index)
                str += ' AND ';


            return str;
        }

    };

    return x.setQueryPath();

};