/* jshint esversion : 6 */

const setColumn = require('../db-columns/cmp');
const cmpIndex = require('../db-indexes/cmp');
const cmpForeignKey = require('../db-foreign-key/cmp');



module.exports = (tableName, { columns, index, foreignKey }) => {

    const path = columns.map(setColumn);

    if (index)
        path.push(cmpIndex(tableName, index));

    if (foreignKey)
        path.push(cmpForeignKey(tableName, foreignKey));


    let query = ("CREATE TABLE IF NOT EXISTS " + tableName + " (" + path.join() + ")");

    if (foreignKey)
        query += " ENGINE=InnoDB;";

    return query;
};