/* jshint esversion : 6 */

require('app-code-js');


const tableSchema = require('./table-schema');

class MySqlTableSchema extends require('./db-table/index') {
    constructor(opt) {
        super(opt);
        this._schemas = {};
    }

    dropSchema(tableName, dbName) {
        const q = $q.defer();

        this.query("DROP TABLE " + this.db_dot_table(tableName, dbName))
            .then(
                () => {
                    delete this._schemas[tableName];
                    q.resolve();
                },
                q.reject
            );

        return q.promise;
    }

    schema(...args) {

        let tableName, opt;

        if (args.length === 1) {
            const a = args[0];
            if ("string" === typeof a)
                tableName = a;
            if ("object" === typeof a) {
                ({ tableName, ...opt } = a);
            }
        } else if (args.length === 2)
            [tableName, opt] = args;



        if (!this._schemas[tableName])
            this._schemas[tableName] = tableSchema(tableName, opt, this);

        return this._schemas[tableName];
    }


    useSchema(tableName) {
        return this._schemas[tableName];
    }


}

module.exports = MySqlTableSchema;