/* jshint esversion : 6 */




const c = require('./db-schema/dbs');


const test = opt => new c(opt);



const x = test({
    host: '192.168.252.70',
    user: 'root',
    password: 'rootapp',
    database: 'test_mysqli_js',
    connectionType: 'pool',
    connectionLimit: 5
});







const categories = x.schema('categories', {

    columns: [{
            name: "cat_id",
            type: "int",
            autoincrement: true,
            null: false
        },
        {
            name: "cat_cod",
            type: "varchar",
            length: 8,
            null: false
        },
        {
            name: "cat_name",
            type: "varchar",
            length: 355,
            null: false
        },

        {
            name: "cat_description",
            type: "text",
            null: true
        },

        {
            name: "test_description",
            type: "text",
            null: true
        }
    ],

    index: [{
        unique: true,
        name: 'cat_idx',
        columns: ['cat_cod']
    }]

});

categories.init().then(
    r => {
        console.log('ok categories', r);


        const products = x.schema('products', {
            columns: [{
                    name: 'prd_id',
                    type: 'int',
                    default: 'NOT NULL',
                    autoincrement: true
                },
                {
                    name: 'prd_name',
                    type: 'varchar',
                    length: 355,
                    null: false
                },
                {
                    name: 'prd_price',
                    type: 'decimal'
                },
                {
                    name: 'cat_id',
                    type: 'int',
                    null: false
                },
                {
                    name: "cat_cod",
                    type: "varchar",
                    length: 9,
                    null: false
                }
            ],

            foreignKey: [{
                name: 'fk_cat_idx',
                columns: 'cat_id',
                parent: 'categories',
                parentColumns: 'cat_id'
            }]

        });


        products.init().then(
            r => console.log('ok products', r),
            err => console.log(err)
        );




        categories.put([{
            cat_cod: 'efg',
            cat_name: 'efg',
            cat_description: 'efg'
        }]).then(
            r => console.log('put category ok', r),
            err => console.log(err)
        );

        /* 
                const watchQuery = categories.watchQueryResult({ fields: '*', where: { cat_cod: 'efgt' }, interval: 800 })

                watchQuery.onChange((o, n) => {
                    console.log('*** change result ***');
                    console.log(n);
                    watchQuery.stop();
                });
         */

        categories.put([{
            cat_cod: 'efgt',
            cat_name: 'efgt',
            cat_description: 'efg'
        }]).then(
            r => {


                setTimeout(() => {
                    categories.put([{
                        cat_cod: 'efgt',
                        cat_name: 'efgt',
                        cat_description: 'effgt is not so an efgt very efgt'
                    }]).then(r => {
                        console.log('ok category put 2'),
                            err => console.log(err)
                    });
                }, 1000);

            }, err => console.log(err)
        );



    },
    err => console.log(err)
);